# Copyright (C) 2012  Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 3 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

EXTERNAL_PY?=python2.7
PY=./bin/py

EXTERNAL_BUILDOUT?=$(EXTERNAL_PY) bootstrap.py
BUILDOUT=./bin/buildout

CA_EGGS_DIR?=../eggs
CA_DOWNLOAD_CACHE_DIR?=../download-cache

clean:
	$(RM) -r bin/buildout
	$(RM) -r bin/py
	$(RM) -r bin/discover
	$(RM) -r develop-eggs
	$(RM) -r parts
	$(RM) -r .installed.cfg
ifeq ($(CA_EGGS_DIR),eggs)
	$(RM) -r eggs
else
	$(RM) eggs
endif
ifeq ($(CA_DOWNLOAD_CACHE_DIR),download-cache)
	$(RM) -r download-cache
else
	$(RM) download-cache
endif

download-cache:
ifeq ($(CA_DOWNLOAD_CACHE_DIR),$@)
	bzr checkout lp:ca-download-cache $@
else
	[ -d $(CA_DOWNLOAD_CACHE_DIR) ] || bzr checkout lp:ca-download-cache $(CA_DOWNLOAD_CACHE_DIR)
	ln -s $(CA_DOWNLOAD_CACHE_DIR) $@
endif

eggs:
ifeq ($(CA_EGGS_DIR),$@)
	mkdir $@
else
	[ -d $(CA_EGGS_DIR) ] || mkdir $(CA_EGGS_DIR)
	ln -s $(CA_EGGS_DIR) $@
endif

$(BUILDOUT): bootstrap.py buildout.cfg setup.py versions.cfg eggs download-cache
	$(EXTERNAL_BUILDOUT) --distribute --version 1.5.1 \
				--download-base=download-cache/dist --eggs=eggs \
				--setup-source distribute_setup.py
	touch --no-create $@

$(PY): $(BUILDOUT)
	$(BUILDOUT)
	touch --no-create $@

bootstrap: clean $(PY)

test: $(PY)
	$(TEST_COMMAND)

check: test

# Can be used to update the dependencies when you change something
# in versions.cfg.
update-deps: $(BUILDOUT)
	$(BUILDOUT) buildout:install-from-cache=false buildout:allow-picked-versions=true

.PHONY: bootstrap check clean test update-deps
.DEFAULT_GOAL := $(PY)
