# encoding: utf-8
import datetime
from south.db import db
from south.v2 import SchemaMigration
from django.db import models

class Migration(SchemaMigration):

    def forwards(self, orm):
        
        # Adding model 'Project'
        db.create_table('revtracker_project', (
            ('id', self.gf('django.db.models.fields.AutoField')(primary_key=True)),
            ('name', self.gf('django.db.models.fields.SlugField')(unique=True, max_length=128, db_index=True)),
            ('deployed_revision', self.gf('django.db.models.fields.related.ForeignKey')(blank=True, related_name='+', null=True, to=orm['revtracker.Revision'])),
            ('branch', self.gf('django.db.models.fields.CharField')(max_length=1024)),
        ))
        db.send_create_signal('revtracker', ['Project'])

        # Adding model 'Revision'
        db.create_table('revtracker_revision', (
            ('id', self.gf('django.db.models.fields.AutoField')(primary_key=True)),
            ('project', self.gf('django.db.models.fields.related.ForeignKey')(to=orm['revtracker.Project'])),
            ('revno', self.gf('django.db.models.fields.IntegerField')()),
            ('status', self.gf('django.db.models.fields.IntegerField')()),
            ('commit_message', self.gf('django.db.models.fields.TextField')()),
            ('assignee', self.gf('django.db.models.fields.CharField')(max_length=128, null=True, blank=True)),
            ('link', self.gf('django.db.models.fields.URLField')(max_length=200)),
        ))
        db.send_create_signal('revtracker', ['Revision'])


    def backwards(self, orm):
        
        # Deleting model 'Project'
        db.delete_table('revtracker_project')

        # Deleting model 'Revision'
        db.delete_table('revtracker_revision')


    models = {
        'revtracker.project': {
            'Meta': {'object_name': 'Project'},
            'branch': ('django.db.models.fields.CharField', [], {'max_length': '1024'}),
            'deployed_revision': ('django.db.models.fields.related.ForeignKey', [], {'blank': 'True', 'related_name': "'+'", 'null': 'True', 'to': "orm['revtracker.Revision']"}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'name': ('django.db.models.fields.SlugField', [], {'unique': 'True', 'max_length': '128', 'db_index': 'True'})
        },
        'revtracker.revision': {
            'Meta': {'ordering': "['project', '-revno']", 'object_name': 'Revision'},
            'assignee': ('django.db.models.fields.CharField', [], {'max_length': '128', 'null': 'True', 'blank': 'True'}),
            'commit_message': ('django.db.models.fields.TextField', [], {}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'link': ('django.db.models.fields.URLField', [], {'max_length': '200'}),
            'project': ('django.db.models.fields.related.ForeignKey', [], {'to': "orm['revtracker.Project']"}),
            'revno': ('django.db.models.fields.IntegerField', [], {}),
            'status': ('django.db.models.fields.IntegerField', [], {})
        }
    }

    complete_apps = ['revtracker']
