YUI().use("node", "isitdeployable-project-info", "isitdeployable-revision", "isitdeployable-templating", function (Y) {

    var csrf_token = Y.one("input[name=csrfmiddlewaretoken]").getAttribute("value");
    Y.isitdeployable.Templating.register_partials();
    Y.isitdeployable.Templating.set_include_project(false);
    Y.isitdeployable.Templating.set_include_assignee(true);
    Y.isitdeployable.Templating.set_csrf_token(csrf_token);

    var project_info = new Y.isitdeployable.ProjectInfo({
        srcNode: "#project_info"
    });
    project_info.render();
    var project_name = project_info.get('data').name;

    var refresh_url = '/api/v1/project/' + project_name;
    var revision_list = new Y.isitdeployable.RevisionList({
        srcNode: "#revision_list",
        response_revision_list_attr: 'undeployed_revisions',
        refresh_url: refresh_url
    });

    function make_revision_recurse(revision_node) {
        var revision = new Y.isitdeployable.Revision({
            srcNode: revision_node,
            refresh_url: refresh_url
        });
        var children = revision_node.all('.revision_wrapper');
        children.each(function(child_node) {
            child_revision = make_revision_recurse(child_node);
            revision.add(child_revision);
        });
        return revision;
    };

    function make_revision(revision_node) {
        if (revision_node.ancestor('.revision', false)) {
            return;
        }
        revision_list.add(make_revision_recurse(revision_node));
    }

    Y.all('.revision_wrapper').each(make_revision);
    revision_list.render('#revision_list_wrapper');

    project_info.on('project_info:deployed_revision_updated', function(e) {
        revision_list.updateRevisions(e.data.undeployed_revisions);
    });
    revision_list.on('revision:revision_status_updated', function(e) {
        project_info.set('data', e.data.project);
    });

    revision_list.grabFocus();
    window.scrollTo(0, 0);
});
