YUI.add("isitdeployable-templating", function (Y) {

    var Templating = Y.Base.create("templating", Y.Base, []);

    Templating.get_template_source = function(name) {
        return Y.one('#' + name + '-template').getHTML();
    };
    Templating.compile_template = function(name) {
        return Y.Handlebars.compile(Templating.get_template_source(name));
    };

    Templating.register_partials = function() {
        Y.Handlebars.registerPartial('revision_form', Templating.get_template_source('revision_form'));
        Y.Handlebars.registerPartial('revision_comment_form', Templating.get_template_source('revision_comment_form'));
        Y.Handlebars.registerPartial('revision_info', Templating.get_template_source('revision_info'));
        Y.Handlebars.registerPartial('deployability_form', Templating.get_template_source('deployability_form'));
    };

    function exclude(options) {
        return '';
    }
    function include(options) {
        return options.fn(this);
    }

    Templating.set_include_project = function(include_project) {
        if (include_project) {
            Y.Handlebars.registerHelper('if_include_project', include);
        } else {
            Y.Handlebars.registerHelper('if_include_project', exclude);
        }
    };
    Templating.set_include_assignee = function(include_assignee) {
        if (include_assignee) {
            Y.Handlebars.registerHelper('if_include_assignee', include);
        } else {
            Y.Handlebars.registerHelper('if_include_assignee', exclude);
        }
    };

    Y.Handlebars.registerHelper('dump_json', function(info) {
        return Y.JSON.stringify(this);
    });

    Y.Handlebars.registerHelper('current_url', function(info) {
        return document.URL;
    });

    Templating.set_csrf_token = function(csrf_token) {
        Y.Handlebars.registerHelper('csrf_token', function() {
            return csrf_token;
        });
    };

    Y.namespace("isitdeployable").Templating = Templating;

}, "0.0.1", { requires: ["base-build", "handlebars", "json-stringify"] });
