#! /bin/bash

ROOTDIR=${ROOTDIR:-`bzr root`}
if [ ! -d "$ROOTDIR"  ]; then
    echo "ROOTDIR '$ROOTDIR' doesn't exist" >&2
    exit 1
fi

function setup_database() {
    local TESTDIR=$1

    echo "## Starting postgres in $TESTDIR ##"
    mkdir -p "$TESTDIR/data"
    chmod 700 "$TESTDIR/data"

    export PGHOST="$TESTDIR"
    export PGDATA="$TESTDIR/data"
    if [ -d /usr/lib/postgresql/9.1 ]; then
        export PGBINDIR=/usr/lib/postgresql/9.1/bin
    elif [ -d /usr/lib/postgresql/8.4 ]; then
        export PGBINDIR=/usr/lib/postgresql/8.4/bin
    else
        echo "Cannot find valid parent for PGBINDIR"
    fi
    $PGBINDIR/initdb -E UNICODE -D $PGDATA
    $PGBINDIR/initdb -A trust &>/dev/null
    $PGBINDIR/pg_ctl start -w -D $TESTDIR/data -l $TESTDIR/postgres.log -o "-F -k $TESTDIR -h ''"
    $PGBINDIR/createdb --encoding UNICODE "revtracker" &>/dev/null
    $PGBINDIR/createlang plpgsql "revtracker"
    $PGBINDIR/createuser --superuser --createdb "postgres" &>/dev/null
    echo "To set your environment so psql will connect to this DB instance type:"
    echo "    export PGHOST=$TESTDIR"
    echo "## Done. ##"
}

setup_database $ROOTDIR/tmp/db
